﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private B4XTable1 As B4XTable
	Dim device As Phone
	Dim MES As ManageExternalStorage '<----- depends on ManagerExternalStorage Class
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	MES.Initialize(Me, "MES")
	Wait For (GetPermissions) Complete(Result As Boolean)
	If Result Then
		B4XTable1.AddColumn("1",B4XTable1.COLUMN_TYPE_TEXT)
		B4XTable1.AddColumn("2",B4XTable1.COLUMN_TYPE_TEXT)
		B4XTable1.AddColumn("3",B4XTable1.COLUMN_TYPE_TEXT)
		Dim l As List
		l.Initialize
		For i = 0 To 10
			l.Add(Array(i&"_"&1, i&"_"&2, i&"_"&3))
		Next
		B4XTable1.SetData(l)
	Else
		ToastMessageShow("Needs the permission !", False)
		ExitApplication
	End If
End Sub

Sub GetPermissions As ResumableSub
	' get the device SDK version
	Dim SdkVersion As Int = device.SdkVersion
	
	' Choose which permission to request in order to access external storgage
	If SdkVersion < 30 Then
		Log("SDK = " & SdkVersion & " : Requesting WRITE_EXTERNAL_STORAGE permission")
		Dim rp As RuntimePermissions
		rp.CheckAndRequest(rp.PERMISSION_WRITE_EXTERNAL_STORAGE) ' Implicit read capability if granted
		Wait For B4XPage_PermissionResult (Permission As String, Result As Boolean)
		Log($"PERMISSION_WRITE_EXTERNAL_STORAGE = ${Result}"$)
		If Result Then
			ToastMessageShow("Permission granted !",False)
			Return True
		Else
			Return False
		End If
	Else
		Log("SDK = " & SdkVersion & " : Requesting MANAGE_EXTERNAL_STORAGE permission")
		Log("On Entry MANAGE_EXTERNAL_STORAGE = " & MES.HasPermission)
		If Not(MES.HasPermission) Then
			MsgboxAsync("This app requires access to all files, please enable the option", "Manage All Files")
			Wait For Msgbox_Result(Res As Int)
			Log("Getting permission")
			MES.GetPermission
			Wait For MES_StorageAvailable
			If MES.HasPermission Then
				ToastMessageShow("Permission granted !",False)
				Return True
			Else
				Return False
			End If
		End If
	End If
End Sub

Sub Button1_Click
	ExportTableToExcel(B4XTable1)
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Public Sub ExportTableToExcel(Table As B4XTable)
	'Log("Exporting table.")
    
	Dim rp As RuntimePermissions
	rp.GetSafeDirDefaultExternal("Download")
    
	Dim Filename As String = "FieldInformation.xlsx"

	Dim Download_Path As String = File.DirRootExternal & "/Download"
	'Log($"File Dir: ${Download_Path}/${Filename}"$)
    
	If File.IsDirectory(File.DirRootExternal , "Download") = False Then
		File.MakeDir(File.DirRootExternal, "Download")
	End If
    
	'Log(File.IsDirectory(File.DirRootExternal , "Download"))

	Dim newWorkbook As WritableWorkbook
	newWorkbook.Initialize(Download_Path, Filename)
	
	Dim sheet1 As WritableSheet
	sheet1 = newWorkbook.AddSheet("Information", 0)

	Dim iColumn As Int = 0

	For Each Column As B4XTableColumn In Table.Columns
		Dim cell As WritableCell
		cell.InitializeText(iColumn, 0, Column.Title)
		sheet1.AddCell(cell)
		iColumn = iColumn + 1
	Next
  
	For i = 1 To Table.Size
		Dim cInt As Int = 0
		For Each Column As B4XTableColumn In Table.Columns
			Dim Row As Object = Table.GetRow(i).Get(Column.Title)
			Dim cell As WritableCell
			cell.InitializeText(cInt, i, Row)
			sheet1.AddCell(cell)
			cInt = cInt + 1
		Next
	Next
  
	'Must call write and close to save the data.
	newWorkbook.Write
	newWorkbook.Close
	xui.msgboxAsync($"File Dir: ${Download_Path}/${Filename}"$, "Table Exported")
End Sub